package de.ozgcloud.apilib.common.command;

import de.ozgcloud.apilib.common.command.grpc.OzgCloudCommandTestFactory;
import de.ozgcloud.vorgang.common.GrpcObject;
import de.ozgcloud.vorgang.common.GrpcProperty;
import de.ozgcloud.vorgang.grpc.command.GrpcCreateCommand;

public class GrpcCreateCommandTestFactory {

	public static final GrpcObject BODY_OBJ = GrpcObject.newBuilder().addProperty(
		GrpcProperty.newBuilder().setName(OzgCloudCommandTestFactory.BODY_FIELD_NAME).addValue(OzgCloudCommandTestFactory.BODY_FIELD_VALUE)).build();

	public static GrpcCreateCommand creatio() {
		return createBuilder().build();
	}

	public static GrpcCreateCommand.Builder createBuilder() {
		return GrpcCreateCommand.newBuilder()
			.setOrder(OzgCloudCommandTestFactory.ORDER)
			.setRelationId(OzgCloudCommandTestFactory.RELATION_ID.toString())
			.setRelationVersion(OzgCloudCommandTestFactory.RELATION_VERSION)
			.setBodyObj(BODY_OBJ);
	}
}
