package de.ozgcloud.apilib.common.command;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.ValueSource;

class OzgCloudCommandStatusTest {

	@Nested
	class From {

		@Test
		void shouldReturnSameInstance() {
			OzgCloudCommandStatus result = OzgCloudCommandStatus.from("ERROR");

			assertThat(OzgCloudCommandStatus.ERROR).isSameAs(result);
		}

		@ParameterizedTest
		@ValueSource(strings = { "PENDING", "FINISHED", "ERROR", "REVOKE_PENDING", "REVOKED" })
		void shouldReturnSameInstance(String status) {
			OzgCloudCommandStatus result = OzgCloudCommandStatus.from(status);

			assertThat(result).isSameAs(OzgCloudCommandStatus.from(status));
		}

		@Test
		void shouldAllowUnkownStatusString() {
			var result = OzgCloudCommandStatus.from("SOMETHING_NEW");

			assertThat(result).isNotNull();
		}

		@Test
		void shouldLearnNewStatus() {
			var result = OzgCloudCommandStatus.from("SOMETHING_NEW");

			assertThat(result).isSameAs(OzgCloudCommandStatus.from("SOMETHING_NEW"));
		}
	}

}
